"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _commander = _interopRequireDefault(require("commander"));

var _package = _interopRequireDefault(require("../../package.json"));

var _start = _interopRequireDefault(require("./start"));

var _config = _interopRequireDefault(require("./config"));

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const debug = (0, _debug.default)('cli');
process.on("uncaughtException", err => {
  debug("Unknow error", err);
  process.stderr.write(`${err}\n`);
  process.exit(12);
});

_commander.default.version(_package.default.version).description(_package.default.description).option("--debug [modules]", "Debug mode");

_commander.default.command("start").alias("s").description("Start bridges").option("--only <bridge>", "Start only the specific bridge").action(_start.default);

_commander.default.command("config").description("Configure ircgram++").action(_config.default);

_commander.default.command("plugins", "Manage plugins");

_commander.default.on("command:*", args => {
  if (args.length && args[0] === 'plugins') {
    return;
  }

  process.stderr.write(`The command ${_commander.default.args[0]}, is not a valid` + ` command, see ${_commander.default._name} --help\n`);
  process.exit(1);
});

const mainCLI = function (args) {
  debug('Run');

  _commander.default.parse(args);

  if (_commander.default.debug) {
    process.env.DEBUG = _commander.default.debug;
  }

  if (!_commander.default.args.length) {
    _commander.default.help();
  }
};

var _default = mainCLI;
exports.default = _default;