"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _commander = _interopRequireDefault(require("commander"));

var _package = _interopRequireDefault(require("../../../package.json"));

var _sync = _interopRequireDefault(require("./sync"));

var _list = _interopRequireDefault(require("./list"));

var _search = _interopRequireDefault(require("./search"));

var _install = _interopRequireDefault(require("./install"));

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const debug = (0, _debug.default)('cli.plugins');
process.on("uncaughtException", err => {
  debug("Unknow error", err);
  process.stderr.write(`${err}\n`);
  process.exit(12);
});

_commander.default.version(_package.default.version).description("Manage ircgrampp plugins").option("--debug [modules]", "Debug mode");

_commander.default.command("sync").description("Sync plugins database").action(_sync.default);

_commander.default.command("list").description("List available plugins").action(_list.default);

_commander.default.command("search").description("Search plugins").usage("[options] {keyword}").option('--max <number>', 'Max results [100]', 100).action(_search.default);

_commander.default.command("install <plugin>").description("Install new plugin").usage("[options] {name}[@version]").option("--enable", "Enable plugin").action(_install.default);

_commander.default.command("enable").description("Enable plugin").usage("{name}").action(_search.default);

_commander.default.command('*').action(cmd => {
  process.stderr.write(`The command ${cmd}, is not a valid` + ` command, see ${_commander.default._name} --help\n`);
  process.exit(1);
});

const mainCLI = function (args) {
  debug('Run');

  _commander.default.parse(args);

  if (_commander.default.debug) {
    process.env.DEBUG = _commander.default.debug;
  }

  if (!_commander.default.args.length) {
    _commander.default.help();
  }
};

var _default = mainCLI;
exports.default = _default;