"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.installPackage = void 0;

var _npm = _interopRequireDefault(require("npm"));

var _config = _interopRequireWildcard(require("./config"));

var _debug = _interopRequireDefault(require("debug"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Promise = require('bluebird');

const debug = (0, _debug.default)('npmwrapper');
const npmDebug = (0, _debug.default)('npmwrapper:npm');

const LIB_PATH = _config.default.get('pluginspath');

const options = {
  global: false,
  prefix: LIB_PATH
};
let loaded;

const load = function () {
  if (loaded) {
    return Promise.resolve();
  }

  return new Promise((resolve, reject) => {
    _npm.default.load(options, err => {
      if (err) {
        return reject(err);
      }

      _npm.default.on('log', (...args) => {
        npmDebug(...args);
      });

      loaded = true;
      return resolve();
    });
  });
};

const installPackage = function (query) {
  return load().then(() => {
    debug('Check or create lib directory');
    return (0, _config.checkDir)(LIB_PATH, true);
  }).then(() => {
    return new Promise((resolve, reject) => {
      debug('Installing package', query);

      _npm.default.install(query, err => {
        if (err) {
          debug('Error installing package', err);
          return reject(err);
        }

        debug('Package installed');
        return resolve();
      });
    });
  });
};

exports.installPackage = installPackage;