"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  loadPlugins: true
};
exports.loadPlugins = void 0;

var _config = _interopRequireDefault(require("../config"));

var _interface = _interopRequireDefault(require("./interface"));

var _debug = _interopRequireDefault(require("debug"));

var _manager = require("./manager");

Object.keys(_manager).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _manager[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _manager[key];
    }
  });
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const debug = (0, _debug.default)('plugins');

const loadPlugins = function (all = false) {
  debug('Load plugins');

  let plugins = _config.default.get('plugins');

  if (!all) {
    plugins = plugins.filter(x => x.enable);
  }

  plugins.forEach(plugOps => {
    _interface.default.load(plugOps.name);
  });
};

exports.loadPlugins = loadPlugins;