"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _package = _interopRequireDefault(require("../../package.json"));

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Promise = require('bluebird');

class PluginInjector {
  constructor(pluginInterface) {
    this._interface = pluginInterface;
    this._debug = (0, _debug.default)(`plugin-${this._interface.name}`);
  }

  getConfig() {
    return this._interface.getConfig();
  }

  get Promise() {
    return Promise;
  }

  get debug() {
    return this._debug;
  }

  get version() {
    return _package.default.version;
  }

}

exports.default = PluginInjector;